#include <windows.h>

typedef struct encode_shellstate {
    BOOL fShowAllObjects:1;
    BOOL fShowExtensions:1;
    BOOL fNoConfirmRecycle:1;
    BOOL fShowSysFiles:1;
    BOOL fShowCompColor:1;
    BOOL fDoubleClickInWebView:1;
    BOOL fDesktopHTML:1;
    BOOL fWin95Classic:1;
    BOOL fDontPrettyPath:1;
    BOOL fShowAttribCol:1;
    BOOL fMapNetDrvBtn:1;
    BOOL fShowInfoTip:1;
    BOOL fHideIcons:1;
    BOOL fWebView:1;
    BOOL fFilter:1;
    BOOL fShowSuperHidden:1;
    BOOL fNoNetCrawling:1;
    DWORD dwWin95Unused;
    UINT uWin95Unused;
    LONG lParamSort;
    int iSortDirection;
    UINT version;
    UINT uNotUsed;
    BOOL fSepProcess:1;
    BOOL fStartPanelOn:1;
    BOOL fShowStartPage:1;
    BOOL fAutoCheckSelect:1;
    BOOL fIconsOnly:1;
    BOOL fShowTypeOverlay:1;
    UINT fSpareFlags;
} ENCODE_SHELLSTATE;

typedef struct decode_shellstate {
    int fShowAllObjects;
    int fShowExtensions;
    int fNoConfirmRecycle;
    int fShowSysFiles;
    int fShowCompColor;
    int fDoubleClickInWebView;
    int fDesktopHTML;
    int fWin95Classic;
    int fDontPrettyPath;
    int fShowAttribCol;
    int fMapNetDrvBtn;
    int fShowInfoTip;
    int fHideIcons;
    int fWebView;
    int fFilter;
    int fShowSuperHidden;
    int fNoNetCrawling;
    DWORD dwWin95Unused;
    UINT uWin95Unused;
    LONG lParamSort;
    int iSortDirection;
    UINT version;
    UINT uNotUsed;
    int fSepProcess;
    int fStartPanelOn;
    int fShowStartPage;
    int fAutoCheckSelect;
    int fIconsOnly;
    int fShowTypeOverlay;
    int fSpareFlags;
} DECODE_SHELLSTATE;

void decodeshellstate(ENCODE_SHELLSTATE *src_shellstate,DECODE_SHELLSTATE *dst_shellstate)
{
	dst_shellstate->fShowAllObjects   = src_shellstate->fShowAllObjects;
    dst_shellstate->fShowExtensions   = src_shellstate->fShowExtensions;
    dst_shellstate->fNoConfirmRecycle = src_shellstate->fNoConfirmRecycle;
    dst_shellstate->fShowSysFiles     = src_shellstate->fShowSysFiles;
    dst_shellstate->fShowCompColor    = src_shellstate->fShowCompColor;
    dst_shellstate->fDoubleClickInWebView = src_shellstate->fDoubleClickInWebView;
    dst_shellstate->fDesktopHTML      = src_shellstate->fDesktopHTML;
    dst_shellstate->fWin95Classic     = src_shellstate->fWin95Classic;
    dst_shellstate->fDontPrettyPath   = src_shellstate->fDontPrettyPath;
    dst_shellstate->fShowAttribCol    = src_shellstate->fShowAttribCol;
    dst_shellstate->fMapNetDrvBtn     = src_shellstate->fMapNetDrvBtn;
    dst_shellstate->fShowInfoTip      = src_shellstate->fShowInfoTip;
    dst_shellstate->fHideIcons        = src_shellstate->fHideIcons;
    dst_shellstate->fWebView          = src_shellstate->fWebView;
    dst_shellstate->fFilter           = src_shellstate->fFilter;
    dst_shellstate->fShowSuperHidden  = src_shellstate->fShowSuperHidden;
    dst_shellstate->fNoNetCrawling    = src_shellstate->fNoNetCrawling;
    dst_shellstate->dwWin95Unused     = src_shellstate->dwWin95Unused;
    dst_shellstate->uWin95Unused      = src_shellstate->uWin95Unused;
    dst_shellstate->lParamSort        = src_shellstate->lParamSort;
    dst_shellstate->iSortDirection    = src_shellstate->iSortDirection;
    dst_shellstate->version           = src_shellstate->version;
    dst_shellstate->uNotUsed          = src_shellstate->uNotUsed;
    dst_shellstate->fSepProcess       = src_shellstate->fSepProcess;
    dst_shellstate->fStartPanelOn     = src_shellstate->fStartPanelOn;
    dst_shellstate->fShowStartPage    = src_shellstate->fShowStartPage;
    dst_shellstate->fAutoCheckSelect  = src_shellstate->fAutoCheckSelect;
    dst_shellstate->fIconsOnly        = src_shellstate->fIconsOnly;
    dst_shellstate->fShowTypeOverlay  = src_shellstate->fShowTypeOverlay;
    dst_shellstate->fSpareFlags       = src_shellstate->fSpareFlags;
	return;
}
